import java.io.*;
import java.net.*;

/**
 * Quickly written class to act as a server that sends numbers to a client app
 * via sockets. It is useful to demonstrate certain dtmf client generating
 * apps... :)
 * 
 * @author Jeffrey Nelson <nelsonjm@macpod.net> http://macpod.net
 * @date 1/20/09
 * Licensed under the GPL v2, see the file LICENSE in this tarball.
 */
public class RoboServ {
	public static final int PORT = 12345;

	public static void main(String[] args) {
		ServerSocket s;
		Socket socket = null;
		DataOutputStream out;
		try {
			s = new ServerSocket(PORT);
			System.out.println("Waiting for connection on port " + s);
		} catch (Exception e) {
			System.out
					.println("Error encountered while creating the server socket.");
			return;
		}

		try {
			// Wait for the client, then close the server socket so we can't get
			// more requests.
			socket = s.accept();
			s.close();
			System.out.println("Connection accepted, type q to quit.: "
					+ socket);
		} catch (Exception e) {
			System.out.println("Error encountered while accepting connection.");
		}

		try {
			// Setup out output stream, and then read characters in from the
			// keyboard ungracefully. typing q quits
			out = new DataOutputStream(socket.getOutputStream());
			char val = 0;
			while (val != 'q') {
				val = (char) System.in.read();
				switch (val) {
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9':
					// Write numbers to the client.
					out.writeByte(val);
					out.flush();
					break;
				case 'q':
				case 10: // This is a carriage return.
					break;
				default:
					System.out.println("Got gibberish!" + val);
					break;
				}
			}
		} catch (Exception e) {
			System.out
					.println("Error encountered while handling comminications.");
		}

		/**
		 * Clean up the socket to be nice.
		 */
		try {
			socket.shutdownInput();
		} catch (Exception e) {
		}
		try {
			socket.shutdownOutput();
		} catch (Exception e) {
		}
		try {
			socket.close();
		} catch (Exception e) {
		}

		System.out.println("Quitting");

	}

}
